clear;
clc;
close all;

load('D_syn.mat');

airforce_img = imread('Airforce_2D.png');
airforce_img = im2double(airforce_img);


airforce_img = airforce_img( 36:380, 81:570, :);
airforce_img_gray = rgb2gray(airforce_img);

imshow(airforce_img, 'border', 'tight');


airforce_img_size = size(airforce_img);

airforce_xrf_HR = zeros(airforce_img_size(1), airforce_img_size(2), 1024);

b1 = Dl(:, 1);
b2 = Dl(:, 2);
b3 = Dl(:, 15);

scal = 'one';
b1_dn = wden(b1,'heursure','s',scal,3,'sym8');
b1_dn(b1_dn < 0) = 0;

b1_dn_s = zeros(1024,1);
for i = 1 : 1024
    b1_dn_s(i) = sum(b1_dn((i-1)*4+1 : (i-1)*4+4))/4;
end

% figure;
% plot(b1_dn_s);

% figure;
% plot(b1);
% figure;
% plot(b1_dn);

b2_dn = wden(b2,'heursure','s',scal,3,'sym8');
b2_dn(b2_dn < 0) = 0;

b2_dn_s = zeros(1024,1);
for i = 1 : 1024
    b2_dn_s(i) = sum(b2_dn((i-1)*4+1 : (i-1)*4+4))/4;
end

% figure;
% plot(b2);
% figure;
% plot(b2_dn);


b3_dn = wden(b3,'heursure','s',scal,3,'sym8');
b3_dn(b3_dn < 0) = 0;

b3_dn_s = zeros(1024,1);
for i = 1 : 1024
    b3_dn_s(i) = sum(b3_dn((i-1)*4+1 : (i-1)*4+4))/4;
end

% figure;
% plot(b3);
% figure;
% plot(b3_dn);

% close all;

hidden_img = zeros(airforce_img_size(1), airforce_img_size(2));
hidden_img(150: 250, 150:350) = 1;

% imshow(hidden_img);

%%  Generate HR ground truth
for i = 1 : airforce_img_size(1)
    for j = 1 : airforce_img_size(2)
        
        airforce_xrf_HR(i, j, :) = airforce_img_gray(i, j) * b1_dn_s + (1 - airforce_img_gray(i, j)) * b2_dn_s + hidden_img(i, j) * b3_dn_s;
        
    end
end



%%  Generate LR input

S = hyperSpatialDown(size(airforce_img, 1), size(airforce_img, 2), 5);

RGB_signal = hyperConvert2d(airforce_img);
RGB_l_signal = RGB_signal * S;
airforce_img_LR = hyperConvert3D(RGB_l_signal, size(airforce_img,1)/5 , size(airforce_img, 2)/5, size(airforce_img,3));

figure;
imshow(airforce_img_LR,'border','tight');

XRF_signal = hyperConvert2d(airforce_xrf_HR);
XRF_l_signal = XRF_signal * S;
airforce_xrf_LR = hyperConvert3D(XRF_l_signal, size(airforce_img,1)/5 , size(airforce_img, 2)/5, size(airforce_xrf_HR,3));

for i = 1 : size(airforce_xrf_LR, 1)
    for j = 1 : size(airforce_xrf_LR, 2)   
%         figure;
%         plot(squeeze(airforce_xrf_LR(i, j, :)));
        
        temp_spectra = awgn(squeeze(airforce_xrf_LR(i, j, :)),25,'measured');
        temp_spectra(temp_spectra < 0) = 0;
        airforce_xrf_LR(i, j, :) = temp_spectra;
        
%         figure;
%         plot(squeeze(airforce_xrf_LR(i, j, :)));
        
    end
end

for i = 1 : size(airforce_xrf_LR,3)
    imshow(airforce_xrf_LR(:,:,i) / max(max(airforce_xrf_LR(:,:,i))));
end

save('syn_data_Square_S_1024.mat','-v7.3')